#include "Datenbank.h"

// Inhalt der LSDatenbank Klasse aus Datenbank.h
// Konstruktor
LSDatenbank::LSDatenbank( InitDatei *zIni )
{
	if( !zIni->wertExistiert( "DBBenutzer" ) )
		zIni->addWert( "DBBenutzer", "loginserveru" );
	if( !zIni->wertExistiert( "DBPasswort" ) )
		zIni->addWert( "DBPasswort", "LTLoginServerPW" );
	if( !zIni->wertExistiert( "DBName" ) )
		zIni->addWert( "DBName", "lenck_tech_db" );
	if( !zIni->wertExistiert( "DBIP" ) )
		zIni->addWert( "DBIP", "127.0.0.1" );
	if( !zIni->wertExistiert( "DBPort" ) )
		zIni->addWert( "DBPort", "5432" );
	datenbank = new Datenbank( zIni->zWert( "DBBenutzer" )->getText(), zIni->zWert( "DBPasswort" )->getText(),
							   zIni->zWert( "DBName" )->getText(), zIni->zWert( "DBIP" )->getText(),
							   (unsigned short)TextZuInt( zIni->zWert( "DBPort" )->getText(), 10 ) );
	InitializeCriticalSection( &cs );
	ref = 1;
}

// Destruktor
LSDatenbank::~LSDatenbank()
{
	datenbank->release();
	DeleteCriticalSection( &cs );
}

// nicht constant
void LSDatenbank::lock()
{
	EnterCriticalSection( &cs );
}

void LSDatenbank::unlock()
{
	LeaveCriticalSection( &cs );
}

int LSDatenbank::istAdministrator( const char *name, const char *passwort )
{
	Text *befehl = new Text( "SELECT id FROM benutzer WHERE name = '" );
	Text n( name );
	n.ersetzen( "'", "''" );
	befehl->append( (char*)n );
	befehl->append( "' AND passwort = '" );
	Text p( passwort );
	p.ersetzen( "'", "''" );
	befehl->append( (char*)p );
	befehl->append( "'" );
	lock();
	datenbank->befehl( befehl->getText() );
	Result res = datenbank->getResult();
	unlock();
	befehl->release();
	int ret = 0;
	if( res.zeilenAnzahl > 0 )
		ret = TextZuInt( res.values[ 0 ].getText(), 10 );
	res.destroy();
	return ret;
}

bool LSDatenbank::adminHatRecht( int id, int recht )
{
	Text *befehl = new Text( "SELECT * FROM benutzer_rechte WHERE benutzer_id = " );
	befehl->append( id );
	befehl->append( " AND rechte_id = " );
	befehl->append( recht );
	lock();
	datenbank->befehl( befehl->getText() );
	int ret = datenbank->getZeilenAnzahl();
	unlock();
	befehl->release();
	return ret != 0;
}

bool LSDatenbank::proveKlient( int num, int sNum )
{
	Text *befehl = new Text( "SELECT * FROM server_login_clients WHERE server_login_id = " );
	befehl->append( sNum );
	befehl->append( " AND client_id = " );
	befehl->append( num );
	lock();
	datenbank->befehl( befehl->getText() );
	Result res = datenbank->getResult();
	unlock();
	befehl->release();
	bool ret = 0;
	if( res.zeilenAnzahl == 1 )
		ret = 1;
	res.destroy();
	return ret;
}

Text *LSDatenbank::getKlientKey( int cId )
{
	lock();
	if( !datenbank->befehl( Text( "SELECT schluessel FROM clients WHERE id = " ) += cId ) )
	{
		unlock();
		return 0;
	}
	Result res = datenbank->getResult();
	unlock();
	if( !res.zeilenAnzahl )
	{
		res.destroy();
		return 0;
	}
	Text *ret = new Text( res.values[ 0 ].getText() );
	res.destroy();
	return ret;
}

void LSDatenbank::unregisterKlient( int num, int sNum )
{
	Text *befehl = new Text( "DELETE FROM server_login_clients WHERE client_id = " );
	befehl->append( num );
	befehl->append( " AND server_login_id = " );
	befehl->append( sNum );
	lock();
	datenbank->befehl( befehl->getText() );
	int za = datenbank->getZeilenAnzahl();
	unlock();
	if( za == 1 )
	{
		befehl->setText( "UPDATE server_login SET clients = clients - 1 WHERE id = " );
		befehl->append( sNum );
		lock();
		datenbank->befehl( befehl->getText() );
		unlock();
	}
	befehl->release();
}

bool LSDatenbank::serverAnmelden( InitDatei *zIni )
{
	if( !zIni->wertExistiert( "ServerId" ) )
		zIni->addWert( "ServerId", "0" );
	if( !zIni->wertExistiert( "ServerName" ) )
		zIni->addWert( "ServerName", "Name" );
	if( !zIni->wertExistiert( "ServerPort" ) )
		zIni->addWert( "ServerPort", "49144" );
	if( !zIni->wertExistiert( "ServerIP" ) )
		zIni->addWert( "ServerIP", "127.0.0.1" );
	if( !zIni->wertExistiert( "AdminServerPort" ) )
		zIni->addWert( "AdminServerPort", "49143" );
	if( !zIni->wertExistiert( "Aktiv" ) )
		zIni->addWert( "Aktiv", "FALSE" );
	if( !zIni->wertExistiert( "MaxClients" ) )
		zIni->addWert( "MaxClients", "50" );
	bool insert = 0;
	int id = *zIni->zWert( "ServerId" );
	if( id )
	{
		lock();
		if( !datenbank->befehl( Text( "SELECT id FROM server_login WHERE id = " ) += id ) )
		{
			unlock();
			return 0;
		}
		int anz = datenbank->getZeilenAnzahl();
		unlock();
		insert = anz == 0;
		if( !insert )
		{
			lock();
			if( !datenbank->befehl( Text( "SELECT id FROM server_login WHERE server_status_id = 1 AND id = " ) += id ) )
			{
				unlock();
				return 0;
			}
			int anz = datenbank->getZeilenAnzahl();
			unlock();
			if( !anz ) // Server luft bereits
				return 0;
		}
	}
	if( insert || !id )
	{ // Neuer Eintrag in Tabelle server_login
		Text *befehl = new Text( "INSERT INTO server_login( " );
		if( id )
			*befehl += "id, ";
		*befehl += "name, ip, port, admin_port, server_status_id, max_clients ) VALUES( ";
		if( id )
		{
			*befehl += id;
			*befehl += ", ";
		}
		*befehl += "'";
		*befehl += zIni->zWert( "ServerName" )->getText();
		*befehl += "', '";
		*befehl += zIni->zWert( "ServerIP" )->getText();
		*befehl += "', ";
		*befehl += zIni->zWert( "ServerPort" )->getText();
		*befehl += ", ";
		*befehl += zIni->zWert( "AdminServerPort" )->getText();
		*befehl += ", 1, ";
		*befehl += zIni->zWert( "MaxClients" )->getText();
		*befehl += " ) RETURNING id";
		lock();
		if( !datenbank->befehl( *befehl ) )
		{
			unlock();
			befehl->release();
			return 0;
		}
		Result res = datenbank->getResult();
		unlock();
		befehl->release();
		if( !res.zeilenAnzahl )
		{
			res.destroy();
			return 0;
		}
		zIni->setWert( "ServerId", res.values[ 0 ] );
		return 1;
	}
	else
	{ // Alten Eintrag aus Tabelle server_login ndern
		Text *befehl = new Text( "UPDATE server_login SET name = '" );
		*befehl += zIni->zWert( "ServerName" )->getText();
		*befehl += "', port = ";
		*befehl += zIni->zWert( "ServerPort" )->getText();
		*befehl += ", ip = '";
		*befehl += zIni->zWert( "ServerIP" )->getText();
		*befehl += "', max_clients = ";
		*befehl += zIni->zWert( "MaxClients" )->getText();
		*befehl += ", admin_port = ";
		*befehl += zIni->zWert( "AdminServerPort" )->getText();
		*befehl += " WHERE id = ";
		*befehl += id;
		lock();
		bool ret = datenbank->befehl( *befehl );
		unlock();
		befehl->release();
		return ret;
	}
}

bool LSDatenbank::setServerStatus( int id, int status )
{
	Text *befehl = new Text( "UPDATE server_login SET server_status_id = " );
	*befehl += status;
	*befehl += "WHERE id = ";
	*befehl += id;
	lock();
	if( !datenbank->befehl( befehl->getText() ) )
	{
		unlock();
		befehl->release();
		return 0;
	}
	bool ret = datenbank->getZeilenAnzahl() != 0;
	unlock();
	befehl->release();
	return ret;
}

bool LSDatenbank::setMaxClients( int id, int maxC )
{
	Text *befehl = new Text( "UPDATE server_login SET max_clients = " );
	befehl->append( maxC );
	befehl->append( " WHERE id = " );
	befehl->append( id );
	lock();
	if( !datenbank->befehl( befehl->getText() ) )
	{
		unlock();
		befehl->release();
		return 0;
	}
	bool ret = datenbank->getZeilenAnzahl() > 0;
	unlock();
	befehl->release();
	return ret;
}

int LSDatenbank::getAdminPort( int id )
{
	Text *befehl = new Text( "SELECT admin_port FROM server_login WHERE id = " );
	befehl->append( id );
	lock();
	if( !datenbank->befehl( befehl->getText() ) )
	{
		unlock();
		befehl->release();
		return 0;
	}
	Result res = datenbank->getResult();
	unlock();
	befehl->release();
	if( !res.zeilenAnzahl )
	{
		res.destroy();
		return 0;
	}
	int ret = TextZuInt( res.values[ 0 ].getText(), 10 );
	res.destroy();
	return ret;
}

bool LSDatenbank::serverIstNichtPausiert( int id )
{
	Text *befehl = new Text( "SELECT server_status_id FROM server_login WHERE id = " );
	befehl->append( id );
	lock();
	if( !datenbank->befehl( befehl->getText() ) )
	{
		unlock();
		befehl->release();
		return 0;
	}
	Result res = datenbank->getResult();
	unlock();
	befehl->release();
	if( !res.zeilenAnzahl )
	{
		res.destroy();
		return 0;
	}
	bool ret = (int)res.values[ 0 ] == 3;
	res.destroy();
	return ret;
}

int LSDatenbank::getAccountId( char *name, char *pass )
{
	Text *befehl = new Text( "SELECT id FROM account WHERE name = '" );
	Text n( name );
	n.ersetzen( "'", "''" );
	befehl->append( (char*)n );
	befehl->append( "' AND passwort = '" );
	Text p( pass );
	p.ersetzen( "'", "''" );
	befehl->append( (char*)p );
	befehl->append( "'" );
	lock();
	datenbank->befehl( befehl->getText() );
	Result res = datenbank->getResult();
	unlock();
	befehl->release();
	if( res.zeilenAnzahl == 0 )
	{
		res.destroy();
		return 0;
	}
	int ret = TextZuInt( res.values[ 0 ].getText(), 10 );
	res.destroy();
	return ret;
}

int LSDatenbank::loginKlient( int klientId, int accountId )
{
	Text *befehl = new Text( "SELECT login_client( " );
	befehl->append( klientId );
	befehl->append( ", " );
	befehl->append( accountId );
	befehl->append( " )" );
	lock();
	datenbank->befehl( befehl->getText() );
	Result res = datenbank->getResult();
	unlock();
	befehl->release();
	if( res.zeilenAnzahl == 0 )
	{
		res.destroy();
		return 0;
	}
	int ret = TextZuInt( res.values[ 0 ].getText(), 10 );
	res.destroy();
	return ret;
}

bool LSDatenbank::accountGeheim( int accountId, char *geheim )
{
	Text *befehl = new Text( "SELECT * FROM account WHERE id = " );
	befehl->append( accountId );
	befehl->append( " AND geheimnis = '" );
	Text g( geheim );
	g.ersetzen( "'", "''" );
	befehl->append( (char*)g );
	befehl->append( "'" );
	lock();
	datenbank->befehl( befehl->getText() );
	Result res = datenbank->getResult();
	unlock();
	befehl->release();
	if( res.zeilenAnzahl == 1 )
	{
		res.destroy();
		return 1;
	}
	res.destroy();
	return 0;
}

int *LSDatenbank::kickKlient( int accountId )
{
	Text *befehl = new Text( "SELECT kick_client( " );
	befehl->append( accountId );
	befehl->append( " )" );
	lock();
	datenbank->befehl( befehl->getText() );
	Result res = datenbank->getResult();
	unlock();
	befehl->release();
	if( res.zeilenAnzahl == 0 )
	{
		res.destroy();
		return 0;
	}
	int *ret = new int[ res.zeilenAnzahl ];
	for( int i = 0; i < res.zeilenAnzahl; i++ )
		ret[ i ] = TextZuInt( res.values[ i ].getText(), 10 );
	res.destroy();
	return ret;
}

void LSDatenbank::accountOnline( int accountId, char *ip, unsigned char *locIp, char *pcName )
{
	Text *befehl = new Text( "INSERT INTO account_online( account_id, ip, loc_ip, pc_name ) VALUES ( " );
	befehl->append( accountId );
	befehl->append( ", '" );
	befehl->append( ip );
	befehl->append( "', '" );
	befehl->append( (int)locIp[ 0 ] );
	befehl->append( "." );
	befehl->append( (int)locIp[ 1 ] );
	befehl->append( "." );
	befehl->append( (int)locIp[ 2 ] );
	befehl->append( "." );
	befehl->append( (int)locIp[ 3 ] );
	befehl->append( "', '" );
	Text n( pcName );
	n.ersetzen( "'", "''" );
	befehl->append( (char*)n );
	befehl->append( "' )" );
	lock();
	datenbank->befehl( befehl->getText() );
	unlock();
	befehl->release();
}

int LSDatenbank::logoutKlient( int klientId, Array< int > *ret )
{
	Text *befehl = new Text( "SELECT logout_client( " );
	befehl->append( klientId );
	befehl->append( " )" );
	lock();
	datenbank->befehl( befehl->getText() );
	Result res = datenbank->getResult();
	unlock();
	befehl->release();
	for( int i = 0; i < res.zeilenAnzahl; i++ )
		ret->set( TextZuInt( res.values[ i ].getText(), 10 ), i );
	int retVal = res.zeilenAnzahl;
	res.destroy();
	return retVal;
}

Text **LSDatenbank::getChatServerIpPort( int id )
{
	Text *befehl = new Text( "SELECT ip, port FROM server_chat WHERE id = " );
	befehl->append( id );
	lock();
	datenbank->befehl( befehl->getText() );
	Result res = datenbank->getResult();
	unlock();
	if( !res.zeilenAnzahl )
	{
		res.destroy();
		return 0;
	}
	Text **ret = new Text*[ 2 ];
	ret[ 0 ] = new Text( res.values[ 0 ].getText() );
	ret[ 1 ] = new Text( res.values[ 1 ].getText() );
	res.destroy();
	return ret;
}

bool LSDatenbank::getSpielServerPortIp( int spielErstelltId, unsigned short *port, Text *ip )
{
	Text *befehl = new Text( "SELECT a.port, a.ip FROM server_spiel a, spiel_erstellt b "
							 "WHERE a.id = b.server_spiel_id AND b.id = " );
	befehl->append( spielErstelltId );
	lock();
	if( !datenbank->befehl( befehl->getText() ) )
	{
		unlock();
		befehl->release();
		return 0;
	}
	Result res = datenbank->getResult();
	unlock();
	befehl->release();
	*port = (unsigned short)TextZuInt( res.values[ 0 ].getText(), 10 );
	ip->setText( res.values[ 1 ].getText() );
	res.destroy();
	return 1;
}

int LSDatenbank::getSpielerAusGruppe( int gruppeId, Array< int > *accountId )
{
	Text *befehl = new Text( "SELECT account_id FROM gruppe_spieler WHERE gruppe_id = " );
	befehl->append( gruppeId );
	lock();
	if( !datenbank->befehl( befehl->getText() ) )
	{
		unlock();
		befehl->release();
		return 0;
	}
	Result res = datenbank->getResult();
	unlock();
	befehl->release();
	int ret = res.zeilenAnzahl;
	for( int i = 0; i < ret; i++ )
		accountId->add( TextZuInt( res.values[ i ].getText(), 10 ), i );
	return ret;
}

int LSDatenbank::kickSpielerAusGruppe( int gruppeId, int accountId )
{
	Text *befehl = new Text( "SELECT spieler_verlaesst_gruppe( " );
	befehl->append( accountId );
	befehl->append( ", " );
	befehl->append( gruppeId );
	befehl->append( " )" );
	lock();
	if( !datenbank->befehl( befehl->getText() ) )
	{
		unlock();
		befehl->release();
		return 0;
	}
	Result res = datenbank->getResult();
	unlock();
	befehl->release();
	int ret = TextZuInt( res.values[ 0 ].getText(), 10 );
	res.destroy();
	return ret;
}

bool LSDatenbank::getChatServerPortIp( int accountId, unsigned short *port, Text *ip )
{
	Text *befehl = new Text( "SELECT a.port, a.ip FROM server_chat AS a, server_chat_clients AS b, account_clients AS c "
							 "WHERE c.client_id = b.client_id AND a.id = b.server_chat_id AND c.account_id = " );
	befehl->append( accountId );
	lock();
	if( !datenbank->befehl( befehl->getText() ) )
	{
		unlock();
		befehl->release();
		return 0;
	}
	Result res = datenbank->getResult();
	unlock();
	befehl->release();
	*port = (unsigned short)TextZuInt( res.values[ 0 ].getText(), 10 );
	ip->setText( res.values[ 1 ].getText() );
	res.destroy();
	return 1;
}

int LSDatenbank::getGruppeAdmin( int gruppeId )
{
	Text *befehl = new Text( "SELECT admin_account_id FROM gruppe WHERE id = " );
	befehl->append( gruppeId );
	lock();
	if( !datenbank->befehl( befehl->getText() ) )
	{
		unlock();
		befehl->release();
		return 0;
	}
	Result res = datenbank->getResult();
	unlock();
	befehl->release();
	if( !res.zeilenAnzahl )
	{
		res.destroy();
		return 0;
	}
	int ret = TextZuInt( res.values[ 0 ].getText(), 10 );
	res.destroy();
	return ret;
}

int LSDatenbank::getSpielerAusChatroom( int chatroomId, Array< int > *accountId )
{
	Text *befehl = new Text( "SELECT account_id FROM chatroom_spieler WHERE chatroom_id = " );
	befehl->append( chatroomId );
	lock();
	if( !datenbank->befehl( befehl->getText() ) )
	{
		unlock();
		befehl->release();
		return 0;
	}
	Result res = datenbank->getResult();
	unlock();
	befehl->release();
	int ret = res.zeilenAnzahl;
	for( int i = 0; i < ret; i++ )
		accountId->add( TextZuInt( res.values[ i ].getText(), 10 ), i );
	return ret;
}

int LSDatenbank::getChatroomAdmin( int chatroomId )
{
	Text *befehl = new Text( "SELECT admin_account_id FROM chatroom WHERE id = " );
	befehl->append( chatroomId );
	lock();
	if( !datenbank->befehl( befehl->getText() ) )
	{
		unlock();
		befehl->release();
		return 0;
	}
	Result res = datenbank->getResult();
	unlock();
	befehl->release();
	if( !res.zeilenAnzahl )
	{
		res.destroy();
		return 0;
	}
	int ret = TextZuInt( res.values[ 0 ].getText(), 10 );
	res.destroy();
	return ret;
}

// constant
Text *LSDatenbank::getLetzterFehler() const
{
	return datenbank->getLetzterFehler();
}

// Reference Counting
LSDatenbank *LSDatenbank::getThis()
{
	ref++;
	return this;
}

LSDatenbank *LSDatenbank::release()
{
	ref--;
	if( !ref )
		delete this;
	return 0;
}